// fcsub.h
#define PPUCTRL      *(char*)0x2000    // PPU䃌WX^
#define PPUMASK      *(char*)0x2001    // PPU}XNWX^
#define PPUSTATUS    *(char*)0x2002    // PPUXe[^XWX^
#define OAMADDR      *(char*)0x2003    // OAMAhX|[g
#define OAMDATA      *(char*)0x2004    // OAMf[^|[g
#define PPUSCROLL    *(char*)0x2005    // PPUXN[WX^
#define PPUADDR      *(char*)0x2006    // PPUAhXWX^
#define PPUDATA      *(char*)0x2007    // PPUf[^WX^
#define JOYPAD1      *(char*)0x4016    // Rg[[1
#define JOYPAD2      *(char*)0x4017    // Rg[[2
#define PULSE1CTR1   *(char*)0x4000    // `g1䃌WX^1
#define PULSE1CTR2   *(char*)0x4001    // `g1䃌WX^2
#define PULSE1FREQ1  *(char*)0x4002    // `g1g1
#define PULSE1FREQ2  *(char*)0x4003    // `g1g2
#define OAMDMA       *(char*)0x4014    // OAM DMAWX^
#define SNDCHANNEL   *(char*)0x4015    // TEh`l
#define SPWADDR      0x700             // XvCg[N̊i[AhX

#define C_BLACK      0x0f  // J[R[h F
#define C_RED        0x16  // J[R[h ԐF
#define C_BLUE       0x12  // J[R[h F
#define C_GREEN      0x1A  // J[R[h ΐF
#define C_YELLOW     0x28  // J[R[h F
#define C_SKYBLUE    0x22  // J[R[h F
#define C_LIMEGREEN  0x29  // J[R[h ΐF
#define C_GRAY       0x00  // J[R[h DF
#define C_LIGHTGRAY  0x10  // J[R[h 邢DF
#define C_WHITE      0x30  // J[R[h F

#define BUTTON_A      0x80   // {^ A
#define BUTTON_B      0x40   // {^ B
#define BUTTON_SELECT 0x20   // {^ SELECT
#define BUTTON_START  0x10   // {^ START
#define BUTTON_UP     0x08   // {^ 
#define BUTTON_DOWN   0x04   // {^ 
#define BUTTON_LEFT   0x02   // {^ 
#define BUTTON_RIGHT  0x01   // {^ E

#define OUTSIDE      240     // ʊO̍W

// S@\̏
void fc_init(void);
// PPUAhXݒ(AhX0x0000`0xffff)
void ppu_address(unsigned short adr);
// BG̏
void bg_cls(void);
// XvCg̏
void sp_cls(void);
// ^̎擾
unsigned int random(void);
// Rg[[1
unsigned char controller1(void);
// TEh
void sound_init(void);
// `g1Đ(g)
void pulse1(unsigned short hz);
// J[pbgݒ(i[|C^, ItZbg0`7, pbg1`8)
void ppu_palette(char *ptable, char ofs, char size);
// p^[e[uݒ(i[|C^, ItZbg0`511, 1`512)
void ppu_pattern(unsigned char *ptable, short ofs, short size);
// ʕ\̗L(1=\ONA0=\OFF)
void ppu_enable(char on);
// VuN҂
void ppu_vsync(void);
// BGXN[ݒ(XWItZbg0`511, YWItZbg0`239)
void bg_scroll(unsigned short x, unsigned char y);
// BGLN^\(XW0`31, YW0`29, ^Cԍ0`255)
void bg_printch(char x, char y, unsigned char c);
// BG\(XW0`31, YW0`29, |C^)
void bg_printstr(char x, char y, char *str);
// BGAgr[gݒ(XW0`31, YW0`29, Agr[g0`255)
void bg_attrib(char x, char y, unsigned char atr);
// 10i5P^ϊ(i[|C^, l0`65535)
void num_to_str(char *str, unsigned short num);
// 16i2P^ϊ(i[|C^, l0`255)
void num_to_hex(char *str, unsigned char num);
// XvCg[NDMA]Jn
void sp_dmastart(void);
// XvCg4 ǉ(XW, YW, ^C0`255, Agr[g0`255)
char sp_append(char x, char y, char tile, char attr);
// XvCg4 (XvCgԍ0`15)
void sp_remove(char i);
// XvCg4 \ύX(XvCgԍ0`15, ^C0`255, Agr[g0`255)
void sp_chr(char num, unsigned char tile, unsigned char attr);
// XvCg4 Aj(XvCgԍ0`15)
void sp_anime(char num);
// XvCg4 ړ(XvCgԍ0`15, XW0`255, YW0`255)
void sp_ofs(char num, unsigned char x, unsigned char y);
// XvCgXW擾(XvCgԍ0`63)
unsigned char sp_getx(char num);
// XvCgYW擾(XvCgԍ0`63)
unsigned char sp_gety(char num);
// XvCg̃^C擾(XvCgԍ0`63)
unsigned char sp_gettile(char num);
// XvCgՓ˔(XvCgԍ0`63, XW, YW)
char sp_hitcheck(char num, unsigned char x, unsigned char y);

