// main.c
#include "fcsub.h"   // 색Cu

// p^[e[u BGp
const unsigned char patternbg[] = {
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 /* BG 0 */
,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff /* BG 1 */
};

// p^[e[u XvCgp
const unsigned char patternsp[] = {
 0x03,0x07,0x07,0x07,0x07,0x07,0x03,0x3c,0x00,0x00,0x01,0x03,0x03,0x03,0x03,0x03 /* SP 0 */
,0xe0,0xf8,0xe0,0xe0,0xf0,0xf3,0xc7,0x3e,0x00,0x00,0xe0,0xa0,0xf0,0xf3,0xc3,0xc0 /* SP 1 */
,0x78,0xe0,0xc7,0x00,0x60,0x60,0x60,0x40,0x07,0xc7,0xc0,0x07,0x1e,0x1c,0x00,0x00 /* SP 2 */
,0x1c,0x00,0xe0,0x00,0x00,0x0e,0x0f,0x00,0xe0,0xe0,0x18,0xfc,0x0c,0x00,0x00,0x00 /* SP 3 */
};

// J[e[u
const char colortable[] = {
  C_BLACK  , 0       , 0       , C_WHITE , // BGpbg0
  C_BLACK  , 0       , 0       , 0       , // BGpbg1
  C_BLACK  , 0       , 0       , 0       , // BGpbg2
  C_BLACK  , 0       , 0       , 0       , // BGpbg3
  C_BLACK  , C_BLUE  , C_RED   , C_YELLOW, // SPpbg0
  C_BLACK  , 0       , 0       , 0       , // SPpbg1
  C_BLACK  , 0       , 0       , 0       , // SPpbg2
  C_BLACK  , 0       , 0       , 0         // SPpbg3
};

// C֐
char NesMain()
{
  unsigned char spnum, x, y;  // XvCgԍAXWAYW
  unsigned char button;       // {^

  fc_init(); // S@\̏
  ppu_pattern((unsigned char *)patternbg,  0,2);  // BGp^[e[u
  ppu_pattern((unsigned char *)patternsp,256,4);  // SPp^[e[u
  ppu_palette((char *)colortable,0,8);      // J[pbgݒ
  spnum = sp_append(128,120,0,0);           // XvCg̒ǉ
  ppu_enable(1);

  while(1){   // C[v
    button = controller1();   // Rg[[1
    x = sp_getx(spnum);  // XvCgXW
    y = sp_gety(spnum);  // XvCgYW
    if(button & BUTTON_UP   )y--;
    if(button & BUTTON_DOWN )y++;
    if(button & BUTTON_RIGHT)x++;
    if(button & BUTTON_LEFT )x--;
    sp_ofs(spnum,x,y);       // XvCg̈ړ
    ppu_vsync();             // VuN҂
    bg_printch(x/8,y/8,1);   // BGւ̕`
    sp_dmastart();           // OMAւDMA]Jn
    bg_scroll(0,0);          // BGXN[
  }
  return 0;
}

