; startup.asm

.setcpu        "6502"
.autoimport    on
.IMPORTZP      sp

.global    _NesMain

; iNESwb_[(16 Bytes)
.segment "HEADER"
    .byte   $4e, $45, $53, $1a ; "NES" 
    .byte   $02                ; PRG-ROMoN(16KB x 2)
    .byte   $00                ; CHR-ROMoN(8KB x 0)
    .byte   $01                ; Mapper 0(low)/Vetrical Mirroring
    .byte   $00                ; Mapper 0(high)
    .byte   $00                ; PRG-RAMTCY
    .byte   $00,$00,$00,$00, $00, $00, $00

.segment "STARTUP"
; Zbg荞
.proc    Reset
    sei
    ldx    #$ff        ; X^bN|C^1
    txs 

    lda    #$ff        ; X^bN|C^2
    sta    sp
    lda    #$03
    sta    sp + 1

    jsr    _NesMain    ; C֐Ăяo
.endproc

.segment "VECINFO"     ; xN^e[u
    .word    $0000     ; NMI荞݃AhX
    .word    Reset     ; Zbg荞݃AhX
    .word    $0000     ; IRQ荞݃AhX

